;PicMimic Example Code
;This code demonstrates the use of the INT (RB0) Interrupt.
;Load the intrb0.hex Hex file with the intrb0.pel Layout file to use.
;The program increments COUNT each time the RB0 pin edge falls, COUNT is output to PORTA

org	0x00                     

;--------- Constants -----------------

    OPTREG	     EQU 0x81
    INTCON           EQU 0x0B       
    PORTB            EQU 0x06       
    PORTA            EQU 0x05       
    TRISA            EQU 0x85       
    TRISB            EQU 0x86       
    STATUS           EQU 0X03      
    COUNT            EQU 0x0c        


goto    main	;skip over interrupt routine                                    
 
;-------- Interrupt Routine ------------------
org	0x04                            
 incf   COUNT,1		;Increment count, store result back in COUNT                                                      
 retfie                                      


;--------- Start of Main Program -----------------
main

;--------- Setup -----------------
 bsf	INTCON,7	;GIE=1, Enable Global Interrupts
 bsf	INTCON,4	;INTE=1, Enable INT (RB0) Interrupt
 bcf	INTCON,1	;INTF=0, Clear INTF flag (is set when INT occurs)
			
 bsf	STATUS,5	;Switch to Bank 1
 bcf	0x81,6	;INTEDG=0, INT will occur on falling edge of RB0
			;	set INTEDG=1 for INT on rising edge.
 movlw 	0x01  		
 movwf 	TRISB		;Set RB0 as Input
 movlw 	0x00		                       
 movwf 	TRISA		;Set PORTA as output
 bcf	STATUS,5	;Switch to Bank 0

;--------- Set PORTA to Count -----------------           
loop
 movf	COUNT,0		;Move COUNT to W
 movwf	PORTA		;Move W (COUNT) to PORTA
 goto	loop		;Repeat

;--------- End of Program -----------------     
end
